/*this is modified by TKP from Spincore code 9/2009 */
#define PTS250
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "spinapi.h"
extern int maxfreq, nopts, fullrange10mhz, allowphase;
extern char dev_descr[64];

void printLicense(void);

int main(int argc, char* argv[])
{
	int ret;
	
	/* set pts variables based on definitions; these external variables are used by the library to define various PTS devices */
	maxfreq = MAXFREQ;
	nopts = NOPTS;
	fullrange10mhz = FULLRANGE10MHZ;
	allowphase = ALLOWPHASE;
	/* this is not needed for most installations 
	strcpy(dev_descr,DEV_DESCR);*/
	
    
	/*set debug state*/
	pb_set_debug(0);
    printf ("USB Interface to PTS Synthesizer developed by SpinCore Technologies\n\n");
    printf ("Using spinapi library version %s\n", pb_get_version ());
    
    printf("\n");
    if (argc != 2)
    {
      printf("Usage: fs250_new <frequency>\n");
      printf("Frequency is in units of MHz.\n");
      exit(1); 
    }
    
        double frequency = atof(argv[1]);
        int phase = 0.0;

        if(frequency < 0.0 || frequency > 250.0)
        {
            printf("Invalid Frequency! Must be between 0 and 250 MHz.\n");
            system("sleep 0.5");
            return -1;  
        }

        else if(frequency == 0.0)
        {
            printf("Program exited on zero frequency!\n");
            system("sleep 0.5");
            return 0;
        }
        else
        {


            ret = set_pts(frequency, phase);
            if(ret == 0)
            	printf("PTS set to %.4lf MHz\n",frequency);
            printf("%s\n", spinpts_get_error() );	//format check OK, send to PTS
            system("sleep 0.5");
        }

    return 0;

}
